v0.4.8 insert option --log-file to prepare to be a service
[osm/openvim.git] / scripts / install-openvim-service.sh
1 #!/bin/bash
2
3 ##
4 # Copyright 2015 Telefónica Investigación y Desarrollo, S.A.U.
5 # This file is part of openvim
6 # All Rights Reserved.
7 #
8 # Licensed under the Apache License, Version 2.0 (the "License"); you may
9 # not use this file except in compliance with the License. You may obtain
10 # a copy of the License at
11 #
12 # http://www.apache.org/licenses/LICENSE-2.0
13 #
14 # Unless required by applicable law or agreed to in writing, software
15 # distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
16 # WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
17 # License for the specific language governing permissions and limitations
18 # under the License.
19 #
20 # For those usages not covered by the Apache License, Version 2.0 please
21 # contact with: nfvlabs@tid.es
22 ##
23
24 #ONLY TESTED for Ubuntu 16.04
25 #it configures openvim to run as a service
26
27 function usage(){
28 echo -e "usage: sudo $0 [OPTIONS]"
29 echo -e "Configures openvim to run as a service"
30 echo -e " OPTIONS"
31 echo -e " -u USER_OWNER user owner of the service, 'root' by default"
32 echo -e " -f PATH path where openvim source is located. If missing it is downloaded from git"
33 #echo -e " -q: install in an unattended mode"
34 echo -e " -h: show this help"
35 echo -e " --uninstall: remove created service and files"
36 }
37
38 function uninstall(){
39 service openvim stop
40 for file in /opt/openvim /etc/default/openvimd.cfg /var/log/openvim /etc/systemd/system/openvim.service
41 do
42 rm -rf $file || ! echo "Can not delete '$file'. Needed root privileges?" >&2 || exit 1
43 done
44 echo "Done"
45 }
46
47 BAD_PATH_ERROR="Path '$FILE' does not contain a valid openvim distribution"
48 GIT_URL=https://osm.etsi.org/gerrit/osm/RO.git
49 USER_OWNER="root"
50 QUIET_MODE=""
51 FILE=""
52 DELETE=""
53 while getopts ":u:f:hq-:" o; do
54 case "${o}" in
55 u)
56 export USER_OWNER="$OPTARG"
57 ;;
58 f)
59 export FILE="$OPTARG"
60 ;;
61 q)
62 export QUIET_MODE=yes
63 ;;
64 h)
65 usage && exit 0
66 ;;
67 -)
68 [ "${OPTARG}" == "help" ] && usage && exit 0
69 [ "${OPTARG}" == "uninstall" ] && uninstall && exit 0
70 echo -e "Invalid option: '--$OPTARG'\nTry $0 --help for more information" >&2
71 exit 1
72 ;;
73 \?)
74 echo -e "Invalid option: '-$OPTARG'\nTry $0 --help for more information" >&2
75 exit 1
76 ;;
77 :)
78 echo -e "Option '-$OPTARG' requires an argument\nTry $0 --help for more information" >&2
79 exit 1
80 ;;
81 *)
82 usage >&2
83 exit -1
84 ;;
85 esac
86 done
87
88 #check root privileges
89 [ "$USER" != "root" ] && echo "Needed root privileges" >&2 && exit 1
90
91 #Discover Linux distribution
92 #try redhat type
93 if [[ -f /etc/redhat-release ]]
94 then
95 _DISTRO=$(cat /etc/redhat-release 2>/dev/null | cut -d" " -f1)
96 else
97 #if not assuming ubuntu type
98 _DISTRO=$(lsb_release -is 2>/dev/null)
99 fi
100 if [[ "$_DISTRO" == "Ubuntu" ]]
101 then
102 _RELEASE=$(lsb_release -rs)
103 if [[ ${_RELEASE%%.*} != 16 ]]
104 then
105 echo "Only tested in Ubuntu Server 16.04" >&2 && exit 1
106 fi
107 else
108 echo "Only tested in Ubuntu Server 16.04" >&2 && exit 1
109 fi
110
111
112 if [[ -z $FILE ]]
113 then
114 git clone $GIT_URL __temp__ || ! echo "Cannot get openvim source code from $GIT_URL" >&2 || exit 1
115 #git checkout <tag version>
116 FILE=./__temp__
117 DELETE=y
118 fi
119
120 #make idenpotent
121 rm -rf /opt/openvim
122 rm -f /etc/default/openvimd.cfg
123 rm -f /var/log/openvim
124 cp -r $FILE /opt/openvim || ! echo $BAD_PATH_ERROR >&2 || exit 1
125 mkdir -p /opt/openvim/logs
126 #cp ${FILE}/openvim /usr/sbin/ || ! echo $BAD_PATH_ERROR >&2 || exit 1
127 ln -s /opt/openvim/openvimd.cfg /etc/default/openvimd.cfg || echo "warning cannot create link '/etc/default/openvimd.cfg'"
128 ln -s /opt/openvim/logs /var/log/openvim || echo "warning cannot create link '/var/log/openvim'"
129
130 chown $USER_OWNER /opt/openvim/openvimd.cfg
131 chown -R $USER_OWNER /opt/openvim
132
133 mkdir -p etc/systemd/system/
134 cat > /etc/systemd/system/openvim.service << EOF
135 [Unit]
136 Description=openvim server
137
138 [Service]
139 User=${USER_OWNER}
140 ExecStart=/opt/openvim/openvimd.py -c /opt/openvim/openvimd.cfg --log-file=/opt/openvim/logs/openvim.log
141 Restart=always
142
143 [Install]
144 WantedBy=multi-user.target
145 EOF
146
147 [[ -n $DELETE ]] && rm -rf $FILE
148
149 service openvim start
150
151 echo Done
152 exit